/*****************************************************************************\
 *                        ANALYSIS PERFORMANCE TOOLS                         *
 *                                   Folding                                 *
 *              Instrumentation package for parallel applications            *
 *****************************************************************************
 *     ___     This library is free software; you can redistribute it and/or *
 *    /  __         modify it under the terms of the GNU LGPL as published   *
 *   /  /  _____    by the Free Software Foundation; either version 2.1      *
 *  /  /  /     \   of the License, or (at your option) any later version.   *
 * (  (  ( B S C )                                                           *
 *  \  \  \_____/   This library is distributed in hope that it will be      *
 *   \  \__         useful but WITHOUT ANY WARRANTY; without even the        *
 *    \___          implied warranty of MERCHANTABILITY or FITNESS FOR A     *
 *                  PARTICULAR PURPOSE. See the GNU LGPL for more details.   *
 *                                                                           *
 * You should have received a copy of the GNU Lesser General Public License  *
 * along with this library; if not, write to the Free Software Foundation,   *
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA          *
 * The GNU LEsser General Public License is contained in the file COPYING.   *
 *                                 ---------                                 *
 *   Barcelona Supercomputing Center - Centro Nacional de Supercomputacion   *
\*****************************************************************************/
#ifndef CUBETREE_H_INCLUDED
#define CUBETREE_H_INCLUDED

#include "callstack-tree.H"
#include <cubelib/Cube.h>

using namespace cube;

class CubeTree
{
	private:
	Cnode *cube_node;
	Region *cube_region;
	CallstackTree *tree_node;
	vector<CubeTree *> children;

	public:
	void generate (Cube &, Cnode *, CallstackTree *, UIParaverTraceConfig *pcf,
	  const string &sourceDir, unsigned depth = 0);
	void setSeverities (Cube &c);
	Cnode *getCubeNode (void)
	  { return cube_node; }
};

#endif /* CUBETREE_H_INCLUDED */
